<?php

function mod_grid_image($module_id, $cfg){
    
    $iPage = cmsPage::getInstance();
    $iPage->addHeadCSS('templates/'.TEMPLATE.'/css/imagegrid.css');
    $iPage->addHeadJS('templates/'.TEMPLATE.'/js/modernizr.custom.26633.js');
    $iPage->addHeadJS('templates/'.TEMPLATE.'/js/jquery.gridrotator.js');

	cmsCore::loadClass('photo');
	$inPhoto = cmsPhoto::getInstance();
	$inDB    = cmsDatabase::getInstance();

	$default_cfg = array (
				  'showmore' => 1,
				  'album_id' => 0,
				  'whatphoto' => 'all',
				  'sort' => 'pubdate',
				  'showclubs' => 0,
				  'is_subs' => 1,
            
                                  'w768raws' => 3,
                                  'w768columns' => 7,
                                  'w320raws' => 2,
                                  'w320columns' => 4,
                                  'step' => -1,
                                  'max_step' => 3,
                                  'animation_speed' => 500,
                                  'interval' => 3000
				);
	$cfg = array_merge($default_cfg, $cfg);

    // выбираем категории фото
    $inDB->addJoin('INNER JOIN cms_photo_albums a ON a.id = f.album_id AND a.published = 1');
    $inDB->addSelect('a.title as cat_title, a.NSDiffer');
    
        if($cfg['step'] <= 0){
            
            $cfg['step'] = "'random'";
            $cfg['max_step'] = 3;
            
        } else { $cfg['max_step'] = $cfg['step']; }
        
        $cfg['anitypes_list'] = array();
        if($cfg['animation_types']=='inputFromText'){
            
            $cfg['anitype_string'] = trim ($cfg['anitype_string']);
            $cfg['anitypes_list'] = explode (',', $cfg['anitype_string']);
            foreach ($cfg['anitypes_list'] as &$anitype) {
                $anitype = trim($anitype);
            }
            
        } else { 
             
            $cfg['anitypes_list'][] = $cfg['animation_types']; 
            
        }

	// если категория задана, выбираем из нее
	if($cfg['album_id']){

		// Если выбирать нужно включая вложенные
		if($cfg['is_subs']){

			// получаем категорию
			$album = $inDB->getNsCategory('cms_photo_albums', $cfg['album_id']);
			if (!$album) { return false; }

			$inPhoto->whereThisAndNestedCats($album['NSLeft'], $album['NSRight']);

		} else {

			$inPhoto->whereAlbumIs($cfg['album_id']);

		}

	}

	// если фото клубов не нужны
	if(!$cfg['showclubs']){
		$inDB->where("f.owner = 'photos'");
	}

	// Задаем период
	$inPhoto->wherePeriodIs($cfg['whatphoto']);

    //устанавливаем сортировку
    $inDB->orderBy('f.'.$cfg['sort'], 'DESC');

	// получаем фото
	$photos = $inPhoto->getPhotos(false, 1);
	if(!$photos) { return false; }

	cmsPage::initTemplate('modules', 'mod_grid_image')->
            assign('photos', $photos)->
            assign('cfg', $cfg)->
            display('mod_grid_image.tpl');

	return true;

}

?>